<template>
  <div class="step-frame">
    <div class="frame">
      <div class="comments-frame">
        <div class="comments-body">
          <AppComment
            v-for="(comment, id) in comments"
            :key="id"
            :text="comment.text"
            :date="
              comment.date
                ? DateTime.fromISO(comment.date).toFormat('dd LLLL y    TT')
                : null
            "
          >
            <AppButton
              :theme="buttonThemes.ico"
              :icon="buttonIcons.editSmall"
              @click="editComment(comment)"
            />
            <AppButton
              :theme="buttonThemes.ico"
              :icon="buttonIcons.removeSmall"
              @click="askForRemoveComment(comment.id)"
            />
          </AppComment>
        </div>
      </div>
      <div class="comments-adding">
        <AppTextArea v-model="comment"> Комментарий к заданию: </AppTextArea>
        <AppButton
          :theme="buttonThemes.prime"
          v-if="!isEditMode"
          @click="createComment"
        >
          Добавить комментарий
        </AppButton>
        <AppButton
          :theme="buttonThemes.prime"
          v-if="isEditMode"
          @click="saveComment"
        >
          Сохранить комментарий
        </AppButton>
      </div>
    </div>
  </div>
  <ModalDialog
    title="Удалить выбранный комментарий ?"
    text="Выбранные вами объекты удалятся без возможности восстановления."
    :show="showDialog"
  >
    <template #actions>
      <AppButton :theme="buttonThemes.light" @click="cancelRemove">
        Отмена
      </AppButton>
      <AppButton :theme="buttonThemes.prime" @click="removeComment">
        Удалить
      </AppButton>
    </template>
  </ModalDialog>
</template>
<script>
import AppTextArea from "@/components/UI/AppTextArea.vue";
import AppButton, {
  themes as buttonThemes,
  icons as buttonIcons,
} from "@/components/UI/AppButton.vue";
import AppComment from "@/components/UI/AppComment.vue";
import ModalDialog from "@/components/ModalDialog.vue";
import { mapState } from "vuex";
import { DateTime } from "luxon";
import store from "@/store";
import baseApi from "@/api/baseApi";

export default {
  name: "TaskStep3",
  data() {
    return {
      buttonThemes,
      buttonIcons,
      currentComment: null,
      comment: null,
      idForRemove: null,
      showDialog: false,
      isEditMode: false, // Редактируем ли мы существующий коммент
    };
  },
  components: { ModalDialog, AppComment, AppButton, AppTextArea },
  computed: {
    isEditStatus: {
      get: () => store.state.isEditMode,
      set: (val) => store.commit("changeEditMode", val),
    },
    DateTime() {
      return DateTime;
    },
    ...mapState({ comments: (state) => state.taskDetails.comments }),
  },
  methods: {
    askForRemoveComment(id) {
      const comment = this.comments.find((item) => item.id === id);
      if (comment) {
        this.showDialog = true;
        this.idForRemove = comment.id;
      }
    },
    setRemove() {
      const idToRemove = this.comments.findIndex(
        (item) => item.id === this.idForRemove
      );
      if (idToRemove !== -1) {
        this.comments.splice(idToRemove, 1);
        this.showDialog = false;
        this.idForRemove = null;
      }
    },
    removeComment() {
      const commentToRemove = this.comments.find(
        (item) => item.id === this.idForRemove
      );
      if (this.isEditStatus) {
        const commentPayload = {
          text: this.comment,
        };
        baseApi
          .delete("/task/comment/" + commentToRemove.id, commentPayload, {})
          .then((res) => {
            if (res.data === true) {
              this.setRemove();
            }
          });
      } else {
        this.setRemove();
      }
    },
    cancelRemove() {
      this.showDialog = false;
    },
    editComment(comment) {
      this.isEditMode = true;
      this.currentComment = comment;
      this.comment = this.currentComment.text; // Вставляем текст в поле редактирования
    },
    setComment() {
      // const commentForUpdate = this.comments.find(
      //   (item) => item.id === this.currentComment.id
      // );
      const idForUpdate = this.comments.findIndex(
        (item) => item.id === this.currentComment.id
      );
      if (idForUpdate >= 0) {
        this.comments[idForUpdate].text = this.comment;
        this.comment = "";
        this.isEditMode = false;
        this.currentComment = null;
      }
    },
    saveComment() {
      if (this.isEditMode) {
        if (this.isEditStatus) {
          const commentPayload = {
            text: this.comment,
          };
          baseApi
            .put("/task/comment/" + this.currentComment.id, commentPayload, {})
            .then((res) => {
              if (!res.data.status) {
                this.setComment();
              }
            });
        } else {
          this.setComment();
        }
      }
    },
    createComment() {
      const text = this.comment;
      const date = DateTime.now();

      this.comment = "";
      if (this.isEditStatus) {
        const commentPayload = { text: text };
        baseApi
          .post(
            "/task/" + this.$route.path.split("/")[3] + "/comment",
            commentPayload,
            {}
          )
          .then((res) => {
            if (!res.data.status) {
              const newId = res.data.id;
              this.comments.push({ newId, text, date });
            }
          });
      } else {
        const newId = this.comments[this.comments.length - 1]?.id + 1;
        // TODO Не лучшее решение, здесь еще подумать надо, в любом случае может быть
        // ситуация когда все локальные комменты решат отредактировать
        let id = 0;
        if (newId) {
          id = newId;
        }
        this.comments.push({ id, text, date });
      }
    },
  },
};
</script>
<style>
.frame {
  display: flex;
}
.frame .comments-frame {
  width: 66%;
  margin-right: 30px;
}

.frame .comments-adding {
  width: 34%;
}

.frame .comments-adding .btn {
  float: right;
}

.frame .comments-adding .btn:last-child {
  margin-right: 0;
  margin-top: 20px;
}

.frame .comments-adding textarea {
  min-height: 350px;
}
.comments-body {
  background: #f2f6f9;
  border-radius: 6px;
  width: 100%;
  padding: 30px;
  height: 500px;
  overflow: hidden auto;
}
</style>
